<template>
  <div id='new_task_content'>
    <h2>Create new task:</h2>
    <div class="form-group new_task_form">
      <p>
        <input
          id='task_title'
          type="text"
          placeholder="Task title"
          class="form-control"
          v-model="taskTitle"
        />
      </p>
      <button id='create_task_btn' class="btn btn-primary" @click='createTask'>Create task</button>
    </div>
  </div>
</template>

<script>
  export default {
    data () {
      return {
        taskTitle: ''
      }
    },
    mounted() {
      if(!this.$store.state.logged) {
        this.$root.$emit('setFlashMsg', { message: 'You must be logged to visit this page', type: 'error' })
        this.$router.push('/')
      }
    },
    methods: {
      createTask() {
        const url = '/api/v1/tasks'
        this.$http.post(url, {task: { title: this.taskTitle }}, { headers: { 'auth-token': this.$store.state.user.auth_token }})
        .then((response) => {
          this.$root.$emit('setFlashMsg', { message: response.body.message, type: 'normal' })
          this.$router.push('/tasks')
        }).catch((error) => {
          this.$root.$emit('setFlashMsg', {message: error.body.message, type: 'error'})
        })
      },
      deleteTask(task) {
        const url = `/api/v1/tasks/${task.id}`
        this.$http.delete(url, { headers: { 'auth-token': this.$store.state.user.auth_token }})
        .then((response) => {
          this.$root.$emit('setFlashMsg', { message: response.body.message, type: 'normal' })
          let taskIndex = this.tasks.indexOf(task)
          this.tasks.splice(taskIndex, 1)
        })
      }
    }
  }
</script>
